/*
	File:		AlbumMainAspect.r

	Contains:	Main aspect resource for album sample template

	Written by: Harry Chesley, Steve Fisher, Bruce Gaya

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

				  5/6/93	BG		revised for 1993 WWDC

	To Do:
*/

#include "Types.r"
#include "OCETemplates.h"
#include "OCE.r"

// --------------------------------------------------------------------
// --------------------------------------------------------------------
//
// Album Main Aspect
//
// --------------------------------------------------------------------
// --------------------------------------------------------------------


/////////////////////////////////////////////////////////////////////////
//
// BOOKKEEPING - this is an aspect template with this base resource id
//
/////////////////////////////////////////////////////////////////////////

#define kAlbumMainAspect		kDETFirstID

resource 'deta' (kAlbumMainAspect, purgeable) {
	0,					// Drop priority
	dropCheckAlways,	// Drop check flag
	isMainAspect		// Is the main aspect
};

resource 'rstr' (kAlbumMainAspect+kDETTemplateName, purgeable) {
	"Album Main Aspect"
};


/////////////////////////////////////////////////////////////////////////
//
// BINDING - associate this aspect with records of this type
//
/////////////////////////////////////////////////////////////////////////

resource 'rstr' (kAlbumMainAspect+kDETRecordType, purgeable) {
	"Album"
};


/////////////////////////////////////////////////////////////////////////
//
// BEHAVIOR - record icons behaviour
//
/////////////////////////////////////////////////////////////////////////

resource 'rst#' (kAlbumMainAspect+kDETAspectCategory,purgeable)
	{{
	"Recordings"
	}};

resource 'rstr' (kAlbumMainAspect+kDETAspectNewMenuName, purgeable) {
	"New Album"
};

resource 'rstr' (kAlbumMainAspect+kDETAspectNewEntryName, purgeable) {
	"untitled album"
};


/////////////////////////////////////////////////////////////////////////
//
// USER INTERFACE RESOURCES - for looking good
//
/////////////////////////////////////////////////////////////////////////

resource 'rstr' (kAlbumMainAspect+kDETAspectKind, purgeable) {
	"album (main aspect)"
};

resource 'rstr' (kAlbumMainAspect+kDETAspectWhatIs, purgeable) {
	"Album\n\nA description of an album."
};


// icons

include "AlbumIcons" 'ICN#'(0) as 'ICN#'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'icl4'(0) as 'icl4'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'icl8'(0) as 'icl8'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'ics#'(0) as 'ics#'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'ics4'(0) as 'ics4'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'ics8'(0) as 'ics8'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);
include "AlbumIcons" 'SICN'(0) as 'SICN'(kAlbumMainAspect+kDETAspectMainBitmap, purgeable);

