#include "Types.r"
#include "OCETemplates.h"
#include "OCE.r"
#include "Track.h"

#define kTrackAspect			(kDETFifthID + kDETIDSep)
#define kTrackInfoPage			(kDETFifthID + (2 * kDETIDSep))






// The aspect

resource 'deta' (kTrackAspect, purgeable) {
	0,					// Drop priority
	dropCheckAlways,	// Drop check flag
	isMainAspect		// Is the main aspect
};

resource 'rstr' (kTrackAspect+kDETTemplateName, purgeable) {
	"Track Aspect"
};

resource 'rstr' (kTrackAspect+kDETAttributeType, purgeable) {
	"Track"
};

resource 'rstr' (kTrackAspect+kDETAspectKind, purgeable) {
	"Track"
};

resource 'rstr' (kTrackAspect+kDETAspectWhatIs, purgeable) {
	"Track\n\nA track on an album."
};

resource 'rst#' (kTrackAspect+kDETAspectCategory, purgeable)
	{{
	"Recordings"
	}};

resource 'rstr' (kTrackAspect+kDETAspectNewMenuName, purgeable) {
	"New Track"
};

data 'detb' (kTrackAspect+kDETAspectNewValue, purgeable) {
	$"626E 7279"							// Tag (bnry)
	$"0000 0001"							// prTrackNumber (1)
	$"0000 0000"							// prTrackMinutes (1)
	$"0000 0000"							// prTrackSeconds (1)
	$"0000 0007 3C74 6974 6C65 3E"			// kDETAspectName (<title>)
	$"0000 000A 3C63 6F6D 706F 7365 723E"	// Composer (<composer>)
	$"0000 000A 3C63 6F6D 6D65 6E74 733E"	// Comments (<comments>)
};

resource 'dett' (kTrackAspect+kDETAspectLookup, purgeable) {
	{
	{"Track"}, typeBinary,
		useForInput, useForOutput, notInSublist, isNotAlias, isNotRecordRef,
		{	
		'long', prTrackNumber, 0;
		'long', prTrackMinutes, 0;
		'long', prTrackSeconds, 0;
		'rstr', kDETAspectName, 0;
		'rstr', prTrackComposer, 0;
		'rstr', prTrackComments, 0
		};
	}
};

include "TrackIcons" 'ICN#'(0) as 'ICN#'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'icl4'(0) as 'icl4'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'icl8'(0) as 'icl8'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'ics#'(0) as 'ics#'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'ics4'(0) as 'ics4'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'ics8'(0) as 'ics8'(kTrackAspect+kDETAspectMainBitmap, purgeable);
include "TrackIcons" 'SICN'(0) as 'SICN'(kTrackAspect+kDETAspectMainBitmap, purgeable);








// The info page

#define kTrackNumberTop				(50)
#define kTrackNumberBottom			(kTrackNumberTop + kDETAppFontLineHeight + 4)
#define kTrackPlayingTimeTop		(kTrackNumberBottom + 4)
#define kTrackPlayingTimeBottom		(kTrackPlayingTimeTop + kDETAppFontLineHeight + 4)
#define kTrackComposerTop			(kTrackPlayingTimeBottom+4)
#define kTrackComposerBottom		(kTrackComposerTop + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4)
#define kTrackCommentsTop			(kTrackComposerBottom + 4)
#define kTrackCommentsBottom		(kTrackCommentsTop + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4 + kDETAppFontLineHeight+4)

#define kTrackEditTextWidth			(23)
#define kTrackSpaceBeforeEditDesc	(25)
#define kTrack1stColumnLeft 		(4)
#define kTrack1stColumnRight 		(kDETAttributeInfoWindWidth/2 - 20)
#define kTrack2ndColumnLeft 		(kTrack1stColumnRight+4)
#define kTrack2ndColumnRight 		(kDETAttributeInfoWindWidth - 8)
#define kTrackSecondsColumnLeft		(kTrack2ndColumnLeft + kTrackSpaceBeforeEditDesc + 40)

resource 'deti' (kTrackInfoPage, purgeable) {
	1000,
	{0, 0, 0, 0},
	selectFirstText, 
	{
	kDETNoProperty, kDETNoProperty, kTrackInfoPage;
	},
	{
	}
};

resource 'rstr' (kTrackInfoPage+kDETTemplateName, purgeable) {
	"Track Info Page"
};

resource 'rstr' (kTrackInfoPage+kDETAttributeType, purgeable) {
	"Track"
};

resource 'rstr' (kTrackInfoPage+kDETInfoPageName, purgeable) {
	"Track Info"
};

resource 'rstr' (kTrackInfoPage+kDETInfoPageMainViewAspect, purgeable) {
	"Track Aspect"
};

// subPage view

resource 'detv' (kTrackInfoPage, purgeable) {
	{
	kDETSubpageIconRect, kDETNoFlags, kDETAspectMainBitmap,
	Bitmap { kDETLargeIcon };

	{kTrackNumberTop, kTrack1stColumnLeft, kTrackNumberBottom, kTrack1stColumnRight}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETBold,
		"Track Number:" };

	{kTrackNumberTop-2, kTrack2ndColumnLeft, kTrackNumberBottom-2, kTrack2ndColumnLeft + kTrackEditTextWidth}, kDETEnabled + kDETNumericOnly, prTrackNumber,
	EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

	{kTrackPlayingTimeTop, kTrack1stColumnLeft, kTrackPlayingTimeBottom, kTrack1stColumnRight}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETBold,
		"Playing Time:" };

	{kTrackPlayingTimeTop-2, kTrack2ndColumnLeft, kTrackPlayingTimeBottom-2, kTrack2ndColumnLeft + kTrackEditTextWidth}, kDETEnabled + kDETNumericOnly, prTrackMinutes,
	EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

	{kTrackPlayingTimeTop, kTrack2ndColumnLeft + kTrackSpaceBeforeEditDesc, kTrackPlayingTimeBottom, kTrackSecondsColumnLeft}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal,
		"Mins" };

	{kTrackPlayingTimeTop-2, kTrackSecondsColumnLeft, kTrackPlayingTimeBottom-2, kTrackSecondsColumnLeft + kTrackEditTextWidth}, kDETEnabled + kDETNumericOnly, prTrackSeconds,
	EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

	{kTrackPlayingTimeTop, kTrackSecondsColumnLeft + kTrackSpaceBeforeEditDesc, kTrackPlayingTimeBottom, kTrack2ndColumnRight}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal,
		"Secs" };

	{kTrackComposerTop, kTrack1stColumnLeft, kTrackComposerBottom, kTrack1stColumnRight}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETBold,
		"Composer:" };

	{kTrackComposerTop-2, kTrack2ndColumnLeft, kTrackComposerBottom-2, kTrack2ndColumnRight}, kDETEnabled + kDETMultiLine, prTrackComposer,
	EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };

	{kTrackCommentsTop, kTrack1stColumnLeft, kTrackCommentsBottom, kTrack1stColumnRight}, kDETNoFlags, kDETNoProperty,
	StaticTextFromView { kDETApplicationFont, kDETApplicationFontSize, kDETRight, kDETBold,
		"Comments:" };

	{kTrackCommentsTop-2, kTrack2ndColumnLeft, kTrackCommentsBottom-2, kTrack2ndColumnRight}, kDETEnabled + kDETMultiLine, prTrackComments,
	EditText { kDETApplicationFont, kDETApplicationFontSize, kDETLeft, kDETNormal };
	}
};


